//========================================================================================
//
//	File:				SLPriDeb.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLPRIDEB_H
#define SLPRIDEB_H

#include "FWEnvDef.h"

#ifndef SLPRISTR_H
#include "SLPriStr.h"
#endif

//========================================================================================
// Extern C Methods
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

	FW_EXPORT void FW_PrivDebugger();
		// Stop execution, drop into a debugger
		
	FW_EXPORT void FW_PrivDebugMessage(const char *message);
		// Stop execution, drop into a debugger, and display message
	
#ifdef FW_DEBUG

	#define FW_PRIV_DEBUGGER_BREAK() 			FW_PrivDebugger()
	
	#define FW_PRIV_DEBUGGER_STRING(message) 	FW_PrivDebugMessage(message)

	#define FW_PRIV_ASSERT(f) 					if(!(f)) FW_PrivDebugMessage(#f)
		// If f evaluates to false, drop into the debugger and display f as string.

	// Convenient symbolic constants to be used with assertions for indicating
	// that some feature is not yet implemented, or that a method must be overridden
	const FW_Boolean Not_Yet_Implemented = false;
	const FW_Boolean Subclass_Responsibility = false;

#else

	#define FW_PRIV_DEBUGGER_BREAK()				((void)0)
	#define FW_PRIV_DEBUGGER_STRING(message)		((void)0)
	#define FW_PRIV_ASSERT(f)						((void)0)

#endif

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif
